%define build_debug 0
%{?_with_debug: %{expand: %%global build_debug 1}}

%define build_debug_package 0
%{?_with_debug_package: %{expand: %%global build_debug_package 1}}

%define build_static 1
%{?_without_static: %{expand: %%global build_static 0}}

%define build_sys_rootcerts 1
%{?_without_sys_rootcerts: %{expand: %%global build_sys_rootcerts 0}}

%if %{build_debug_package}
# Debug packages need a debug build too. Set the flag.
%define build_debug 1
%endif

%define name_orig	qca
%define qtdir		%{_prefix}/lib/qt4
%define qtcryptodir	%{qtdir}/plugins/%{_lib}/crypto
# Not define as libqca but libqca2 because qca2 use qt4 and qca1 use qt3
%define lib_name_orig	libqca2
%define lib_major	2
%define lib_name	%mklibname %{name_orig} %{lib_major}
%define source_ver	%{version}-beta2

Name:		qca2
Version:	2.0
Release:	%mkrel 0.beta2.4
License:	LGPL
Summary:	Straightforward and cross-platform crypto API for Qt
Group:		System/Libraries
URL:		http://delta.affinix.com/qca
########################################################################################
#it is now part of kde : You can find it here:  http://webcvs.kde.org//kdesupport/qca/ #
########################################################################################
Source0:	%{name_orig}-%{source_ver}.tar.bz2
# Patch0 should not be necessary, but Qt 4 in Cooker currently builds everything as
# debug, regardless that the documentation says that it should build as release. This
# breaks QCA's build.
Patch0: %{name_orig}-2.0-beta2-config-release.patch
# I don't know if Patch1 is necessary for when Qt 4 in Cooker is fixed. Just in case
# it is needed, I'm leaving it here (it can't hurt). (This patch is the opposite of 0.)
Patch1: %{name_orig}-2.0-beta2-config-debug.patch
# Patch2 allows one to force QCA to use the bundled certs.
Patch2: %{name_orig}-2.0-beta2-certs-bundled.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires: %{lib_name} = %{version}-%{release}
# Only Qt 4.1 is really needed, but older Qt RPMs were quite buggy.
BuildRequires:	qt4-devel >= 2:4.1.1
%if %{build_sys_rootcerts}
BuildRequires:	rootcerts >= 0.1
%endif

%description
The QCA library provides an easy API for a range of cryptographic
features, including SSL/TLS, X.509 certificates, SASL, symmetric
ciphers, public key ciphers, hashes and much more.

Functionality is supplied via plugins. This is useful for avoiding
dependence on a particular crypto library and makes upgrading easier,
as there is no need to recompile your application when adding or
upgrading a crypto plugin. Also, by pushing crypto functionality into
plugins, applications are free of legal issues, such as export
regulation.

%files
%defattr(0644,root,root,0755)
%doc README COPYING INSTALL TODO
%defattr(0755,root,root,0755)
%{qtdir}/bin/qcatool
%{_bindir}/qca2tool

#------------------------------------------------------------------------------

%if ! %{build_sys_rootcerts}
%package -n %{name}-root-certificates
Summary:	Common root CA certificates for QCA
Group:		System/Libraries
Requires:	%{lib_name} = %{version}-%{release}

%description	-n %{name}-root-certificates
Provides root Certificate Authority certificates for the QCA library.
These certificates are the same ones that are included in Mozilla.

%files -n %{name}-root-certificates
%defattr(0644,root,root,0755)
%dir %{qtdir}/share/qca
%dir %{qtdir}/share/qca/certs
%doc %{qtdir}/share/qca/certs/README
%{qtdir}/share/qca/certs/rootcerts.pem
%endif

#------------------------------------------------------------------------------

%package	-n %{lib_name}
Summary:	Libraries for QCA
Group: System/Libraries
%if %{build_sys_rootcerts}
Requires: rootcerts >= 0.1
Obsoletes: %{name}-root-certificates
%else
Requires: %{name}-root-certificates >= %{version}
%endif

%description	-n %{lib_name}
Libraries for QCA

%post -n %{lib_name} -p /sbin/ldconfig
%postun -n %{lib_name} -p /sbin/ldconfig

%files -n %{lib_name}
%defattr(0644,root,root,0755)
%doc README COPYING INSTALL TODO
%dir %{qtcryptodir}
%defattr(0755,root,root,0755)
%{qtdir}/%_lib/libqca.so.*

#------------------------------------------------------------------------------

%package	-n %{lib_name}-devel
Summary:	Development files for QCA
Group:		Development/KDE and Qt
Requires: %{lib_name} = %{version}-%{release}
Provides: %{lib_name_orig}-devel = %{version}-%{release}
Provides: %{name}-devel = %{version}-%{release}
Provides: %{_lib}qca2-devel

%description	-n %{lib_name}-devel
Development files for QCA

%files	-n %{lib_name}-devel
%defattr(0644,root,root,0755)
%_libdir/pkgconfig/qca.pc
%{qtdir}/include/QtCrypto/*.h
%{qtdir}/include/QtCrypto/QtCrypto
%{qtdir}/%_lib/libqca.so
%{qtdir}/mkspecs/features/crypto.prf

#------------------------------------------------------------------------------

%if %{build_static}
%package -n %{lib_name}-static-devel
Summary:	Static development files for QCA
Group:		Development/KDE and Qt
Requires:	%{lib_name}-devel = %{version}-%{release}
Provides:	%{lib_name_orig}-static-devel = %{version}-%{release}
Provides:	%{name}-static-devel = %{version}-%{release}

%description -n %{lib_name}-static-devel
Static development files for QCA.

%files -n %{lib_name}-static-devel
%defattr(0644,root,root,0755)
%{qtdir}/%{_lib}/libqca.a
%endif

#------------------------------------------------------------------------------

%prep
%setup -q -n %{name_orig}-%{source_ver}
%if %{build_debug}
%patch1 -p1 -b .debugpatch
%else
%patch0 -p1 -b .releasepatch
%endif
%patch2 -p1 -b .certstorepathfix


%build
%if %{build_static}
./configure \
   --prefix=%{qtdir} \
   --libdir=%{qtdir}/%{_lib} \
   %if %{build_sys_rootcerts}
   --certstore-path=%{_sysconfdir}/pki/tls/cert.pem \
   %else
   --certstore-path='%bundled%' \
   %endif
   %if %{build_debug}
   --enable-debug \
   %endif
   --static \
	--qtdir=%{qtdir} \
	--disable-tests

# Fix link order so an old QCA lib won't get linked in
for tool in qcatool mozcerts; do
   pushd tools/${tool}
      %{qtdir}/bin/qmake ${tool}.pro -unix -o Makefile
      sed "s>^\\(LIBS[ 	]*= *\$(SUBLIBS) *\\)\\(-L%{qtdir}/%{_lib} *\\)\\(-L../../lib -lqca *\\)\\(.*\$\\)>\\1\\3\\2\\4>" Makefile > Makefile.fix
      mv -f Makefile.fix Makefile
   popd
done

make

# keep libqca.a
mkdir static_keep
mv lib/libqca.a static_keep/

# clean static build
make clean
%endif

./configure \
	--prefix=%{qtdir} \
	--libdir=%{qtdir}/%{_lib} \
%if %{build_sys_rootcerts}
	--certstore-path=%{_sysconfdir}/pki/tls/cert.pem \
%else
	--certstore-path='%bundled%' \
%endif
%if %{build_debug}
	--enable-debug \
%endif
	--qtdir=%{qtdir} \
	--disable-tests

for tool in qcatool mozcerts; do
   pushd tools/${tool}
   %{qtdir}/bin/qmake ${tool}.pro -unix -o Makefile
   sed "s>^\\(LIBS[ 	]*= *\$(SUBLIBS) *\\)\\(-L%{qtdir}/%{_lib} *\\)\\(-L../../lib -lqca *\\)\\(.*\$\\)>\\1\\3\\2\\4>" Makefile > Makefile.fix
   mv -f Makefile.fix Makefile
   popd
done

make

%install
rm -rf %{buildroot}
make install INSTALL_ROOT=%{buildroot}

%if %{build_static}
install -m 644 static_keep/libqca.a %{buildroot}/%{qtdir}/%{_lib}/
%endif

# Make directory for plugins
install -d -m 755 %{buildroot}/%{qtcryptodir}

# Move pkgconfig files to right place
install -d -m 755 %{buildroot}/%{_libdir}/pkgconfig
mv %{buildroot}/%{qtdir}/*/pkgconfig/* %{buildroot}/%{_libdir}/pkgconfig/
rm -rf %{buildroot}/%{qtdir}/*/pkgconfig

# Make symlink in /usr/bin to qcatool
install -d -m 755 %{buildroot}/%{_bindir}
ln -s %{qtdir}/bin/qcatool %{buildroot}/%{_bindir}/qca2tool

%if %{build_debug} && !%{build_debug_package}
# Tell spec-helper not to stip files.
export DONT_STRIP=1
%endif

%clean
rm -rf %buildroot



%changelog
* Thu May 11 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-05-11 10:21:07 (27088)
- Provides as libqca2-devel and not libqca which is build against qt3
  and not qt4

* Tue May 09 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-05-09 16:47:39 (27021)
- Minor modfication from Cliff Dugal and Davi Walluck

* Thu May 04 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-05-04 16:44:06 (26885)
- qt4 is not nice with parallel building :-(

* Thu May 04 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-05-04 16:33:55 (26884)
- New layout for package. Thanks to Cliff Dugal for his work.

* Fri Apr 07 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-04-07 16:39:39 (26381)
- New upstream release beta2
- New package thanks to Cliff Dugal. Post adjusts will be needed

* Mon Mar 06 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-03-06 01:04:48 (1870)
- Fix pkgconfig install dir

* Mon Mar 06 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-03-06 00:42:15 (1869)
- Fix typo

* Mon Mar 06 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-03-06 00:12:04 (1867)
- Be assure that lib is installed in proper arch dir

* Sun Mar 05 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-03-05 23:50:17 (1866)
- First package for qca2 ready. A good solution to sit in Qt space for this
  specific qca sets comes to avoid problems between old and new qca packages

* Sat Mar 04 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-03-04 16:06:13 (1860)
- Copy old qca package to create new qca2 package
  A    svn+ssh://helio@svn.mandriva.com/svn/mdv/cooker/qca2

* Mon Dec 12 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-12-12 19:27:18 (1288)
- Proper patch for libdir

* Mon Dec 12 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-12-12 19:20:41 (1287)
- Patch for lib64 should be applied just for 64

* Mon Dec 12 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-12-12 19:16:49 (1286)
- Initial svn import
- Relocate plugins for correct arch path, lib64 or lib.
- Cleaned spec removing old perl changes for lib64. Now just one patch is needed

* Mon Dec 12 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-12-12 18:16:27 (1282)
- Create current for qca package
